#define GAD_NONE      0 
#define GAD_COLLECTOR 1
#define GAD_SLIDER    2
#define GAD_BUTTON    3
#define GAD_TOGGLE    4
#define GAD_TEXTBOX   5
#define GAD_DECOR     6

struct gadlist;
typedef union _gadget Gadget;

struct pm
{
   int x,y;
   int width,height;
   Window win;
   Pixmap pmap;
   Pixmap mask;
};

typedef _string
{
   int lines;
   char **text;
   char *font;
   int style;
   int sizex;
   int sizey;
   unsigned char justification;
   struct pm image;
} String;

typedef struct
{
   char *name;
   struct gadlist *child;
} Gadget_None;

typedef struct
{
   char *name;
   unsigned char pos_rel;
   int x,y;
   unsigned char size_rel;
   int width,height;
   unsigned char changed;
   Window win;
   Image *bg;
   char visible;
   struct gadlist *child;
} Gadget_Collector;

typedef struct
{
   char *name;
   unsigned char pos_rel;
   int x,y;
   unsigned char size_rel;
   int width,height;
   unsigned char changed;
   Window win;
   Image *unsel;
   Image *sel;
   Image *bg;
   int bar_x;
   int bar_y;
   int bar_width;
   int bar_height;
   int bar_scale_x;
   int bar_scale_y;
   int bar_jump_x;
   int bar_jump_y;
   void *callback (Gadget *gad, int x, int y, int button, int modifier);
   char *command;
} Gadget_Slider;

typedef struct
{
   char *name;
   unsigned char pos_rel;
   int x,y;
   unsigned char size_rel;
   int width,height;
   unsigned char changed;
   Window win;
   Image *unsel;
   Image *sel;
   Image *hilite;
   String *unsel_txt;
   String *sel_txt;
   String *hilite_txt;
   void *callback (Gadget *gad, int x, int y, int button, int modifier);
   char *command;
} Gadget_Button;

typedef struct
{
   char *name;
   unsigned char pos_rel;
   int x,y;
   unsigned char size_rel;
   int width,height;
   unsigned char changed;
   Window win;
   Image  *hilite;
   int num_states;
   int state;
   Image **sate_im;
   String *state_txt;
   void *callback (Gadget *gad, int x, int y, int button, int modifier);
   char *command;
} Gadget_Toggle;

typedef struct
{
   char *name;
   unsigned char pos_rel;
   int x,y;
   unsigned char size_rel;
   int width,height;
   unsigned char changed;
   Window win;
   Image  *bg;
   unsigned char editable; /* 0=display, 1=display,copy&paste, 2=full edit */
   int max_x;
   int max_y;
   int cursor_x;
   int cursor_y;
   int selection_start_x;
   int selection_start_y;
   int selection_end_x;
   int selection_end_y;
   String contents;
   void *callback (Gadget *gad, int x, int y, int button, int modifier);
   char *command;
} Gadget_Textbox;

typedef struct
{
   char *name;
   unsigned char pos_rel;
   int x,y;
   unsigned char size_rel;
   int width,height;
   unsigned char changed;
   Window win;
   Image  *bg;
} Gadget_Decor;

union _gadget
{
   unsigned char    type;
   Gadget_None      none;
   Gadget_Collector collector;
   Gadget_Slider    slider;
   Gadget_Button    button;
   Gadget_Toggle    toggle;
   Gadget_Textbox   textbox;
   Gadget_Decor     decor;
};

struct gadlist
{
   Gadget *gad;
   struct gadlist *next;
};

